{# Template for nftables rollback systemd file #}
#!/usr/bin/env sh
{{ ansible_managed | comment }}

# Variables
config_dir="{{ firewall_vars_nftables_config_dir.path }}"
config_file=$(basename "{{ firewall_vars_nftables_config_main_file.path }}")

abort_rollback() {
    printf "Automatic rollback of firewall config stopped successfully\n"
    exit 0
}

perform_rollback() {
    # Get latest backup file
    backup_file=$(find "$config_dir" -maxdepth 1 -type f -name "${config_file}.*" | awk -F . '{print $0, gensub(/[-~:@]/, "", "g", $NF)}' | sort -nrk2 | cut -d ' ' -f 1 | head -1)

    if [ -z "$backup_file" ]; then
        printf "No backup exists\n"
        printf "Automatic rollback of firewall config can not be completed\n"
        exit 0
    fi
    if [ ! -f "$backup_file" ]; then
        printf "Invalid backup file: %s\n" "$backup_file"
        printf "Automatic rollback of firewall config can not be completed\n"
        exit 0
    fi

    mv "${config_dir}/${config_file}" "${config_dir}/${config_file}.tmp"
    mv "$backup_file" "${config_dir}/${config_file}"
    rm -f "${config_dir}/${config_file}.tmp"

    systemctl restart nftables

    echo "Automatic rollback of firewall config performed."
    echo "Config rolled back to: $backup_file"
}


trap abort_rollback SIGINT SIGTERM SIGKILL

sleep "{{ firewall_settings_rollback_timeout }}" && perform_rollback
